Attribute VB_Name = "Module1"
Declare Function EnumPrinters Lib "winspool.drv" Alias "EnumPrintersA" (ByVal Flags As Long, _
                                                                        ByVal pName As String, _
                                                                        ByVal Level As Long, _
                                                                        pPrinterInfo As Any, _
                                                                        ByVal cdBuf As Long, _
                                                                        pcbNeeded As Long, _
                                                                        pcReturned As Long) As Long

Declare Function EnumPrinterDrivers Lib "winspool.drv" Alias "EnumPrinterDriversA" (ByVal pName As String, _
                                                                                    ByVal pEnvironment As String, _
                                                                                    ByVal Level As Long, _
                                                                                    pDriverInfo As Any, _
                                                                                    ByVal cdBuf As Long, _
                                                                                    pcbNeeded As Long, _
                                                                                    pcRetruned As Long) As Long

Declare Sub MoveMemory Lib "kernel32.dll" Alias "RtlMoveMemory" (Destination As Any, _
                                                                 Source As Any, _
                                                                 ByVal Length As Long)

Declare Function lstrcpy Lib "kernel32.dll" Alias "lstrcpyA" (lpString1 As Any, _
                                                              lpString2 As Any) As Long

Public Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, _
                                                                               ByVal lpSubKey As String, _
                                                                               ByVal ulOptions As Long, _
                                                                               ByVal samDesired As Long, _
                                                                               phkResult As Long) As Long

Public Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long

Public Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, _
                                                                                     ByVal lpValueName As String, _
                                                                                     ByVal lpReserved As Long, _
                                                                                     lpType As Long, _
                                                                                     lpData As Any, _
                                                                                     lpcbData As Long) As Long

Public Const HKEY_LOCAL_MACHINE = &H80000002
Public Const ERROR_SUCCESS = 0&
Public Const KEY_QUERY_VALUE = &H1

Type PRINTER_INFO_2
        pServerName As Long
        pPrinterName As Long
        pShareName As Long
        pPortName As Long
        pDriverName As Long
        pComment As Long
        pLocation As Long
        pDevMode As Long
        pSepFile As Long
        pPrintProcessor As Long
        pDatatype As Long
        pParameters As Long
        pSecurityDescriptor As Long
        Attributes As Long
        Priority As Long
        DefaultPriority As Long
        StartTime As Long
        UntilTime As Long
        Status As Long
        cJobs As Long
        AveragePPM As Long
End Type

Public Type DRIVER_INFO_3
    cVersion As Long
    pName As Long
    pEnvironment As Long
    pDriverPath As Long
    pDataFile As Long
    pConfigFile As Long
    pHelpFile As Long
    pDependentFiles As Long
    pMonitorName As Long
    pDefaultDataType As Long
End Type

Public Const PRINTER_ENUM_LOCAL = &H2


Public Type StarPrinterStatus_2
    ' printer status 1
    coverOpen As Long                   ' Cover Status
    offline As Long                     ' ONLINE/OFFLINE Status
    compulsionSwitch As Long            ' not supported in TUP900

    ' printer status 2
    overTemp As Long                    ' Stopped by high head temperature
    unrecoverableError As Long          ' Non-recoverable Error
    cutterError As Long                 ' Auto-cutter Error
    mechError As Long                   ' not supported in TUP900
    headThermistorError As Long         ' not supported in TUP900

    ' printer status 3
    receiveBufferOverflow As Long       ' Receive Buffer Overflow
    pageModeCmdError As Long            ' Command Error (in Page Mode)
    blackMarkError As Long              ' BM Error
    presenterPaperJamError As Long      ' Presenter Paper Jam Error
    headUpError As Long                 ' not supported in TUP900
    voltageError As Long                ' not supported in TUP900

    ' printer status 4
    receiptBlackMarkDetection As Long   ' not supported in TUP900
    receiptPaperEmpty As Long           ' Paper End
    receiptPaperNearEmptyInner As Long  ' Paper Near-end(Inner Side)
    receiptPaperNearEmptyOuter As Long  ' not supported in TUP900

    ' printer status 5
    presenterPaperPresent As Long       ' not supported in TUP900
    peelerPaperPresent As Long          ' not supported in TUP900
    stackerFull As Long                 ' not supported in TUP900
    slipTOF As Long                     ' not supported in TUP900
    slipCOF As Long                     ' not supported in TUP900
    slipBOF As Long                     ' not supported in TUP900
    validationPaperPresent As Long      ' not supported in TUP900
    slipPaperPresent As Long            ' not supported in TUP900

    ' printer status 6
    etbAvailable As Long                ' ETB Available
    etbCounter As Byte                  ' ETB Counter

    ' printer status 7
    presenterState As Byte              ' Presenter Paper Position

    ' raw
    rawLength As Long                   ' Raw data Length
    raw(63) As Byte                     ' Raw data
End Type

Public Declare Function GetStarPrinterStatus Lib "stsmon.dll" Alias "GetStarPrinterStatusA" (ByVal queueName As String, ByRef currentStatus As StarPrinterStatus_2) As Long

Public Declare Function GetStarLmPlugGuid Lib "stsmon.dll" Alias "GetStarLmPlugGuidA" (ByVal StarLmPlugGuid As String, ByVal StarLmPlugInfo As String) As Long

Public Const SMJLMHOST2DLL = "Star Language Monitor Host 2"
Public Const STLM_REG_PATH = "SOFTWARE\StarMicronics\SMJLMHOST2\Star TUP992 Raster Printer"
Public Const STLM_NAME = "stlm.dll"
Public Const STSMON_NAME = "stsmon.dll"

